#include <stdlib.h>
#include <stdio.h> 
#include <stdint.h>
#include <string.h>
#include <stddef.h>

#define READSIZE 256


int readline(FILE *file, char *contents)
{
int a, c, i;

for(i = 0; i < READSIZE - 1; i++)
	{
	while(1)
		{
		c = getc(file);
		a = ferror(file);
		if(a)
			{
			perror("readline():");
			continue;
			}
		break;
		}
	if(feof(file) )
		{
		fclose(file);
		contents[i] = 0;/* EOF marker */
		return(EOF);
		}
	if(c == '\n')
		{
		contents[i] = 0;/* string termination */
		return(1);/* end of line */
		} 
	contents[i] = c;
	}
/*
mmm since we are here, the line must be quite long, possibly something
is wrong.
Since I do not always check for a return 0 in the use uf this function,
just to be safe, gona force a string termination.
This prevents stack overflow, and variables getting overwritten.
*/
contents[i] = 0;/* force string termination */

//if(debug_flag)
	{
	fprintf(stderr, "readline(): line to long, returning 0 contents=%s\n", contents);
	}

return 0;
} /* end function readline */


int main(int argc, char **argv)
{
int a;
uint32_t ip;
FILE * fptr;
char text[256];
char ab[20];
char country[256];
uint32_t min, max;
int line;
const char delimiters[] = ",";
char *token, *cp;

if(argc != 5)
	{
	fprintf(stderr, "Usage: value1 value2 value3 value4\n");

	exit(1);
	}

ip = (atoi(argv[1]) << 24) |  (atoi(argv[2]) << 16) |  (atoi(argv[3]) << 8) | atoi(argv[4]);

fprintf(stdout, "ip=%s.%s.%s.%s %u ", argv[1], argv[2], argv[3], argv[4], ip);

fptr = fopen("/root/download/html/ip-to-country/ip-to-country.csv", "r");
if(! fptr)
	{
	fprintf(stderr, "could not open cvs file /root/download/html/ip-to-country/ip-to-country.csv for read, aborting.\n");	

	exit(1);
	}

line = 1;
while(1)
	{
	a = readline(fptr, text);
	if(a == EOF)
		{
		fprintf(stdout, "not found.\n");

		exit(1);
		}

	/*	"1372164096","1372168191","DE","DEU","GERMANY" */

	token = strtok (text, delimiters);
	min = atoi(token + 1);

	token = strtok (NULL, delimiters);
	max = atoi(token + 1);

	token = strtok (NULL, delimiters);
	strcpy(ab, token);	

	token = strtok (NULL, delimiters);
	// not used 

	token = strtok (NULL, delimiters);
	strcpy(country, token);

	if( (ip >= min) && (ip <= max) )
		{
		fprintf(stdout, "%s %s\n", ab, country);		

		/* found */		
		exit(0);
		}
	
	line++;
	}

/* never here */
exit(1);
} /* end function main */

  